VERSION 5.00
Begin VB.UserControl DualListBox 
   ClientHeight    =   3615
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5925
   ScaleHeight     =   3615
   ScaleWidth      =   5925
   Begin VB.CommandButton cmdAddAll 
      Caption         =   ">>"
      Height          =   330
      Left            =   2730
      TabIndex        =   5
      Top             =   630
      Width           =   435
   End
   Begin VB.CommandButton cmdRemoveOne 
      Caption         =   "<"
      Height          =   330
      Left            =   2730
      TabIndex        =   4
      Top             =   3045
      Width           =   435
   End
   Begin VB.CommandButton cmdRemoveAll 
      Caption         =   "<<"
      Height          =   330
      Left            =   2730
      TabIndex        =   3
      Top             =   2625
      Width           =   435
   End
   Begin VB.CommandButton cmdAddOne 
      Caption         =   ">"
      Height          =   330
      Left            =   2730
      TabIndex        =   2
      Top             =   210
      Width           =   435
   End
   Begin VB.ListBox lstRight 
      Height          =   3570
      Left            =   3255
      MultiSelect     =   2  'Extended
      TabIndex        =   1
      Top             =   0
      Width           =   2640
   End
   Begin VB.ListBox lstLeft 
      Height          =   3570
      Left            =   0
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   0
      Width           =   2640
   End
End
Attribute VB_Name = "DualListBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private oDragCol As Collection
Private eDragSource As DragSourceEnum

Private Enum DragSourceEnum
    Left
    Right
End Enum

'public left event declarations
Public Event ClickLeft()
Public Event DblClickLeft()
Public Event ItemCheckLeft(Item As Integer)
Public Event KeyDownLeft(KeyCode As Integer, Shift As Integer)
Public Event KeyPressLeft(KeyAscii As Integer)
Public Event KeyUpLeft(KeyCode As Integer, Shift As Integer)
Public Event MouseDownLeft(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMoveLeft(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUpLeft(Button As Integer, Shift As Integer, X As Single, Y As Single)
'public right event declarations
Public Event ClickRight()
Public Event DblClickRight()
Public Event ItemCheckRight(Item As Integer)
Public Event KeyDownRight(KeyCode As Integer, Shift As Integer)
Public Event KeyPressRight(KeyAscii As Integer)
Public Event KeyUpRight(KeyCode As Integer, Shift As Integer)
Public Event MouseDownRight(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMoveRight(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUpRight(Button As Integer, Shift As Integer, X As Single, Y As Single)

'Pubilc Left Events
Private Sub lstLeft_Click()
    RaiseEvent ClickLeft
End Sub

Private Sub lstLeft_DblClick()
    RaiseEvent DblClickLeft
End Sub

Private Sub lstLeft_ItemCheck(Item As Integer) 'used with checkbox
    RaiseEvent ItemCheckLeft(Item)
End Sub

Private Sub lstLeft_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDownLeft(KeyCode, Shift)
End Sub

Private Sub lstLeft_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPressLeft(KeyAscii)
End Sub

Private Sub lstLeft_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUpLeft(KeyCode, Shift)
End Sub

Private Sub lstLeft_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDownLeft(Button, Shift, X, Y)
End Sub

Private Sub lstLeft_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMoveLeft(Button, Shift, X, Y)
End Sub

Private Sub lstLeft_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUpLeft(Button, Shift, X, Y)
End Sub

'Pubilc Right Events
Private Sub lstRight_Click()
    RaiseEvent ClickRight
End Sub

Private Sub lstRight_DblClick()
    RaiseEvent DblClickRight
End Sub

Private Sub lstRight_ItemCheck(Item As Integer) 'used with checkbox
    RaiseEvent ItemCheckRight(Item)
End Sub

Private Sub lstRight_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDownRight(KeyCode, Shift)
End Sub

Private Sub lstRight_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPressRight(KeyAscii)
End Sub

Private Sub lstRight_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUpRight(KeyCode, Shift)
End Sub

Private Sub lstRight_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDownRight(Button, Shift, X, Y)
End Sub

Private Sub lstRight_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMoveRight(Button, Shift, X, Y)
End Sub

Private Sub lstRight_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUpRight(Button, Shift, X, Y)
End Sub


'Public Methods
Public Function AddLeftItem(Item As String, Optional Index As Integer = -1)
    If Index = -1 Then
        lstLeft.AddItem Item
    Else
        lstLeft.AddItem Item, Index
    End If
End Function

Public Function AddRightItem(Item As String, Optional Index As Integer = -1)
    If Index = -1 Then
        lstRight.AddItem Item
    Else
        lstRight.AddItem Item, Index
    End If
End Function

Public Function ClearLeft()
    lstLeft.Clear
End Function

Public Function ClearRight()
    lstRight.Clear
End Function

Public Function RemoveItemLeft(Index As Integer)
    lstLeft.RemoveItem Index
End Function

Public Function RemoveItemRight(Index As Integer)
    lstRight.RemoveItem Index
End Function

Public Function RefreshLeft()
    lstLeft.Refresh
End Function

Public Function RefreshRight()
    lstRight.Refresh
End Function


'public properties
Public Property Get EnabledLeft() As Boolean
    EnabledLeft = lstLeft.Enabled
End Property
Public Property Let EnabledLeft(ByVal NewValue As Boolean)
    lstLeft.Enabled = NewValue
    If NewValue = True Then
        cmdAddOne.Enabled = True
        cmdAddAll.Enabled = False
    Else
        cmdAddOne.Enabled = False
        cmdAddAll.Enabled = False
    End If
End Property

Public Property Get EnabledRight() As Boolean
    EnabledRight = lstRight.Enabled
End Property
Public Property Let EnabledRight(ByVal NewValue As Boolean)
    lstRight.Enabled = NewValue
    If NewValue = True Then
        cmdRemoveOne.Enabled = True
        cmdRemoveAll.Enabled = True
    Else
        cmdRemoveOne.Enabled = False
        cmdRemoveAll.Enabled = False
    End If
End Property

Public Property Get TextLeft() As String
   TextLeft = lstLeft.Text
End Property

Public Property Get TextRight() As String
   TextRight = lstRight.Text
End Property

Public Property Let ListLeft(ByVal Index As Integer, ByVal NewValue As String)
    lstLeft.List(Index) = NewValue
End Property
Public Property Get ListLeft(ByVal Index As Integer) As String
   ListLeft = lstLeft.List(Index)
End Property

Public Property Let ListRight(ByVal Index As Integer, ByVal NewValue As String)
    lstRight.List(Index) = NewValue
End Property
Public Property Get ListRight(ByVal Index As Integer) As String
   ListRight = lstRight.List(Index)
End Property

Public Property Get ListCountLeft() As Integer
   ListCountLeft = lstLeft.ListCount
End Property

Public Property Get ListCountRight() As Integer
   ListCountRight = lstRight.ListCount
End Property

Public Property Let ListIndexLeft(ByVal NewValue As Integer)
    lstLeft.ListIndex = NewValue
End Property
Public Property Get ListIndexLeft() As Integer
   ListIndexLeft = lstLeft.ListIndex
End Property

Public Property Let ListIndexRight(ByVal NewValue As Integer)
    lstRight.ListIndex = NewValue
End Property
Public Property Get ListIndexRight() As Integer
   ListIndexRight = lstRight.ListIndex
End Property

Public Property Get NewIndexLeft() As Integer
   NewIndexLeft = lstLeft.NewIndex
End Property

Public Property Get NewIndexRight() As Integer
   NewIndexRight = lstRight.NewIndex
End Property

Public Property Get SelCountLeft() As Integer
   SelCountLeft = lstLeft.SelCount
End Property

Public Property Get SelCountRight() As Integer
   SelCountRight = lstRight.SelCount
End Property

Public Property Get SelectedLeft(ByVal Index As Integer) As Boolean
    SelectedLeft = lstLeft.Selected(Index)
End Property
Public Property Let SelectedLeft(ByVal Index As Integer, ByVal NewValue As Boolean)
    lstLeft.Selected(Index) = NewValue
End Property

Public Property Get SelectedRight(ByVal Index As Integer) As Boolean
    SelectedRight = lstRight.Selected(Index)
End Property
Public Property Let SelectedRight(ByVal Index As Integer, ByVal NewValue As Boolean)
    lstRight.Selected(Index) = NewValue
End Property

Public Property Get ItemDataLeft(ByVal Index As Integer) As Long
    ItemDataLeft = lstLeft.ItemData(Index)
End Property
Public Property Let ItemDataLeft(ByVal Index As Integer, ByVal NewValue As Long)
    lstLeft.ItemData(Index) = NewValue
End Property

Public Property Get ItemDataRight(ByVal Index As Integer) As Long
    ItemDataRight = lstRight.ItemData(Index)
End Property
Public Property Let ItemDataRight(ByVal Index As Integer, ByVal NewValue As Long)
    lstRight.ItemData(Index) = NewValue
End Property

'stuff to impliment later
'lstLeft.Style '0=standard, 1=checked
'lstLeft.Font
'lstLeft.FontBold
'lstLeft.FontItalic
'lstLeft.FontName
'lstLeft.FontSize
'lstLeft.FontUnderline
'lstLeft.ForeColor
'lstLeft.BackColor




'Private Events
Private Sub cmdAddAll_Click()
    Dim X As Integer
    For X = 1 To lstLeft.ListCount
        lstRight.AddItem lstLeft.List(0)
        lstRight.ItemData(lstRight.NewIndex) = lstLeft.ItemData(0)
        lstLeft.RemoveItem 0
    Next
    UpdateButtons
End Sub

Private Sub cmdAddOne_Click()
    Dim iIndex As Integer
        
    If lstLeft.ListCount = 0 Then Exit Sub
    If lstLeft.ListIndex = -1 Then Exit Sub
    
    iIndex = lstLeft.ListIndex
    lstRight.AddItem lstLeft.List(lstLeft.ListIndex)
    lstRight.ItemData(lstRight.NewIndex) = lstLeft.ItemData(lstLeft.ListIndex)
    lstLeft.RemoveItem (lstLeft.ListIndex)
    
    If lstLeft.ListCount > 0 Then
        If iIndex = 0 Then
            lstLeft.Selected(0) = True
        Else
            lstLeft.Selected(iIndex - 1) = True
        End If
    End If
    UpdateButtons
End Sub

Private Sub cmdRemoveAll_Click()
    Dim X As Integer
    For X = 1 To lstRight.ListCount
        lstLeft.AddItem lstRight.List(0)
        lstLeft.ItemData(lstLeft.NewIndex) = lstRight.ItemData(0)
        lstRight.RemoveItem 0
    Next
    UpdateButtons
End Sub

Private Sub cmdRemoveOne_Click()
    Dim iIndex As Integer
    
    If lstRight.ListCount = 0 Then Exit Sub
    If lstRight.ListIndex = -1 Then Exit Sub
    
    iIndex = lstRight.ListIndex
    lstLeft.AddItem lstRight.List(lstRight.ListIndex)
    lstLeft.ItemData(lstLeft.NewIndex) = lstRight.ItemData(lstRight.ListIndex)
    lstRight.RemoveItem (lstRight.ListIndex)
    
    If lstRight.ListCount > 0 Then
        If iIndex = 0 Then
            lstRight.Selected(0) = True
        Else
            lstRight.Selected(iIndex - 1) = True
        End If
    End If
    UpdateButtons
End Sub

Private Sub lstLeft_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim oItem As ListItem
    Dim z As Integer
    Dim bFirst As Integer
    
    'dont want to drag onto the same control
    If eDragSource = Left Then Exit Sub
    
    For Each oItem In oDragCol
        lstLeft.AddItem oItem.ItemText
        lstLeft.ItemData(lstLeft.NewIndex) = oItem.ItemData
        If bFirst = True Then
            lstRight.RemoveItem oItem.ItemKey
        Else
            lstRight.RemoveItem oItem.ItemKey - z
        End If
        z = z + 1
    Next
    Set oDragCol = Nothing
End Sub

Private Sub lstLeft_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    Dim X As Integer
    Dim oItem As ListItem
    Set oDragCol = New Collection
    For X = 0 To lstLeft.ListCount - 1
        If lstLeft.Selected(X) = True Then
            Set oItem = New ListItem
            oItem.ItemText = lstLeft.List(X)
            oItem.ItemKey = X
            oItem.ItemData = lstLeft.ItemData(X)
            oDragCol.Add oItem, "KEY|" & X
            Set oItem = Nothing
        End If
    Next
    eDragSource = Left
End Sub

Private Sub lstRight_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim oItem As ListItem
    Dim z As Integer
    Dim bFirst As Boolean
    
    'dont want to drag onto the same control
    If eDragSource = Right Then Exit Sub
    
    For Each oItem In oDragCol
        lstRight.AddItem oItem.ItemText
        lstRight.ItemData(lstRight.NewIndex) = oItem.ItemData
        If bFirst = True Then
            lstLeft.RemoveItem oItem.ItemKey
        Else
            lstLeft.RemoveItem oItem.ItemKey - z
        End If
        z = z + 1
    Next
    Set oDragCol = Nothing
End Sub

Private Sub lstRight_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    Dim X As Integer
    Dim oItem As ListItem
    Set oDragCol = New Collection
        
    For X = 0 To lstRight.ListCount - 1
        If lstRight.Selected(X) = True Then
            Set oItem = New ListItem
            oItem.ItemText = lstRight.List(X)
            oItem.ItemKey = X
            oItem.ItemData = lstRight.ItemData(X)
            oDragCol.Add oItem, "KEY|" & X
            Set oItem = Nothing
        End If
    Next
    eDragSource = Right
End Sub

Private Sub UserControl_Initialize()
    lstRight.OLEDragMode = vbOLEDragAutomatic
    lstRight.OLEDropMode = vbOLEDragAutomatic
    lstLeft.OLEDragMode = vbOLEDragAutomatic
    lstLeft.OLEDropMode = vbOLEDragAutomatic
End Sub

Private Sub UserControl_Resize()
    'width
    cmdAddOne.Left = ((UserControl.Width / 2) - (cmdAddOne.Width / 2))
    cmdAddAll.Left = cmdAddOne.Left
    cmdRemoveOne.Left = cmdAddOne.Left
    cmdRemoveAll.Left = cmdAddOne.Left
    lstLeft.Width = cmdAddOne.Left - 105
    lstRight.Left = cmdAddOne.Left + cmdAddOne.Width + 105
    lstRight.Width = UserControl.Width - lstLeft.Width - cmdAddOne.Width - 210
    
    'height
    lstLeft.Height = UserControl.Height
    lstRight.Height = UserControl.Height
    cmdRemoveOne.Top = UserControl.Height - 210 - cmdRemoveOne.Height
    cmdRemoveAll.Top = cmdRemoveOne.Top - 105 - cmdRemoveAll.Height
End Sub


'Private Methods
Private Sub UpdateButtons()
    If lstRight.ListCount > 0 Then
        cmdRemoveOne.Enabled = True
        cmdRemoveAll.Enabled = True
    Else
        cmdRemoveOne.Enabled = False
        cmdRemoveAll.Enabled = False
    End If
    
    If lstLeft.ListCount > 0 Then
        cmdAddOne.Enabled = True
        cmdAddAll.Enabled = True
    Else
        cmdAddOne.Enabled = False
        cmdAddAll.Enabled = False
    End If
End Sub

Private Sub UserControl_Terminate()
    Set oDragCol = Nothing
End Sub


